Bug 426182 - 3.3.2 Update Bugzilla/RPC/Admin.pm and Bugzilla/RPC/User.pm
3.3.2 Update Bugzilla/RPC/Admin.pm and Bugzilla/RPC/User.pm
Status: CLOSED WONTFIX
Product: Bugzilla
Classification: Community
Component: Bugzilla General (Show other bugs)
3.2
All Linux
low Severity low (vote)
: ---
: ---
Assigned To: Noura El hawary
:
Depends On:
Blocks: RHBZ30UpgradeTracker 406131 427053
  Show dependency treegraph
 
Reported: 2007-12-18 20:48 EST by Noura El hawary
Modified: 2013-06-24 00:18 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-01-07 19:59:51 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Noura El hawary 2007-12-18 20:48:41 EST
As part of making Our XMLRPC API compatible with the upstream API ,, we will
update Bugzilla/RPC/User.pm to include all the functions in the upstream
WebService/User.pm and add our additional ones this will require moving some
functions from Bugzilla/RPC/Admin.pm to Bugzilla/RPC/User.pm "addUser and name
it create" . 

Also We will add new module Bugzilla/RPC/Admin.pm which doesn't exist in the
Upstream bugzilla.
Comment 1 Noura El hawary 2007-12-18 21:17:07 EST
LOC Calculation:
(using historical data)

rh_bugzilla_2_18/Bugzilla/RPC/User.pm = 65 LOC
rh_bugzilla_2_18/Bugzilla/RPC/Admin.pm = 607 LOC

bugzilla_3/Bugzilla/WebService/User.pm = 67 LOC

So basically the total LOC for this task will be = 607 + 67 = 674 LOC


For unit testing,,

We have existing xmlrpc testcases for xmlrpc functions in User.pm and Admin.pm 
total existing LOC for that is : 608

There are additional tests to be added for functions: addComponent,
getAllgroups, UserInfo, idToName ,, In average an xmlrpc testcase is about 100
LOC so will need additional 400 LOC for testing 

so in total:

LOC = 674 + 608 + 400 = 
Comment 2 Noura El hawary 2007-12-19 08:41:05 EST
Using FP method for LOC estimation:

as in :
https://engineering.redhat.com/trac/bugzilla-3.0-rh/wiki/XmlrpcCrossComparison

for Admin.pm mostly all the functions are new to upstream except for addUser

LOC for Admin.pm:
Inputs: username, password, data hash with user/group info, data hash with 
        component details = 4 
Outputs:  authentication errors, input validation errors, logging messages, list 
          of groups, user details, component details = 5
Inquiries : group data, user data, component data, bugs data = 4
Logical files : database tables: groups, user_group_map, components, profiles, 
                bugs, component_cc = 6
External Files = Zero

FP total count (simple weighting factor) = (3*4)+(4*5)+(3*4)+(7*6)+(5*0) = 86

FP = 86 * 1.11 =  95

LOC for Admin.pm = 95 * 60 = 5700 LOC


For User.pm 
Inputs: username, password, hash with user details = 3
Outputs: authentication errors, input validation errors, logging messages,
         user details = 4
Inquiries = 0
logical files = 0 
external files = 0 

FP total count (simple weighting factor) = (3*4)+(4*3) = 24

FP = 24 * 1.11 =  27

LOC = 27 * 60 = 1620 


For unit testing,,

We have existing xmlrpc testcases for xmlrpc functions in User.pm and Admin.pm 
total existing LOC for that is : 608

There are additional tests to be added for functions: addComponent,
getAllgroups, UserInfo, idToName ,, In average an xmlrpc testcase is about 100
LOC so will need additional 400 LOC for testing 

Testing code = 608 + 400 = 1008 LOC


TOTAL LOC = Admin.pm code + User.pm Code + testing code = 
               5700       +         1620 +         1008 =  8328
Comment 3 Noura El hawary 2008-01-07 19:59:51 EST
This bug is high level bug, It will be replaced by bugs for each xmlrpc
function. CLosing bug

Noura


Note You need to log in before you can comment on or make changes to this bug.